diff -Naur -x .svn stamp-0.9.10/vacation/vacation.c stamp-0.9.10_Distribute/vacation/vacation.c
--- stamp-0.9.10/vacation/vacation.c	2008-09-09 07:42:06.000000000 +0900
+++ stamp-0.9.10_Distribute/vacation/vacation.c	2014-12-18 12:25:05.961567069 +0900
@@ -67,12 +67,17 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
 #include <stdlib.h>
 #include <stdio.h>
+#if defined(__370__) || defined(_AIX)
+#include <unistd.h>  /* For getopt() */
+#else
 #include <getopt.h>
+#endif
 #include "client.h"
 #include "customer.h"
 #include "list.h"
@@ -87,6 +92,10 @@
 #include "tm.h"
 #include "types.h"
 #include "utility.h"
+#if defined(__bgq__)
+#include <stdint.h>
+#include <spi/include/kernel/location.h>
+#endif
 
 enum param_types {
     PARAM_CLIENTS      = (unsigned char)'c',
@@ -362,9 +371,9 @@
     long maxCustomerId = queryRange + 1;
     for (i = 1; i <= maxCustomerId; i++) {
         if (MAP_FIND(customerTablePtr, i)) {
-            if (MAP_REMOVE(customerTablePtr, i)) {
+	  /*if (MAP_REMOVE(customerTablePtr, i)) {
                 assert(!MAP_FIND(customerTablePtr, i));
-            }
+		}*/
         }
     }
 
@@ -374,9 +383,9 @@
         for (i = 1; i <= numRelation; i++) {
             if (MAP_FIND(tablePtr, i)) {
                 assert(manager_add[t](managerPtr, i, 0, 0)); /* validate entry */
-                if (MAP_REMOVE(tablePtr, i)) {
+                /*if (MAP_REMOVE(tablePtr, i)) {
                     assert(!MAP_REMOVE(tablePtr, i));
-                }
+		    }*/
             }
         }
     }
@@ -418,6 +427,46 @@
 
     /* Initialization */
     parseArgs(argc, (char** const)argv);
+#if defined(__bgq__)
+    if (global_params[PARAM_CLIENTS] < 0) {
+	uint32_t rank;
+	long maxThreads;
+
+	maxThreads = -global_params[PARAM_CLIENTS];
+	rank = Kernel_GetRank();
+	switch (rank) {
+	case 0:
+	    global_params[PARAM_CLIENTS] = 1;
+	    break;
+#if defined(GLOBAL_LOCK) || defined(HTM_IBM)
+	case 1:
+	    global_params[PARAM_CLIENTS] = 2;
+	    break;
+	case 2:
+	    global_params[PARAM_CLIENTS] = 4;
+	    break;
+	case 3:
+	    global_params[PARAM_CLIENTS] = 8;
+	    break;
+	case 4:
+	    global_params[PARAM_CLIENTS] = 16;
+	    break;
+	case 5:
+	    global_params[PARAM_CLIENTS] = 32;
+	    break;
+	case 6:
+	    global_params[PARAM_CLIENTS] = 64;
+	    break;
+#endif
+	default:
+	    exit(0);
+	    break;
+	}
+	if (maxThreads < global_params[PARAM_CLIENTS]) {
+	    exit(0);
+	}
+    }
+#endif
     SIM_GET_NUM_CPU(global_params[PARAM_CLIENTS]);
     managerPtr = initializeManager();
     assert(managerPtr != NULL);
diff -Naur -x .svn stamp-0.9.10/yada/Defines.common.mk stamp-0.9.10_Distribute/yada/Defines.common.mk
--- stamp-0.9.10/yada/Defines.common.mk	2008-09-09 07:42:08.000000000 +0900
+++ stamp-0.9.10_Distribute/yada/Defines.common.mk	2014-12-18 12:40:35.730671094 +0900
@@ -3,8 +3,12 @@
 # Defines.common.mk
 #
 # ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
 
 
+hostname := $(shell hostname)
+
+CFLAGS += -DUSE_TLH
 CFLAGS += -DLIST_NO_DUPLICATES
 CFLAGS += -DMAP_USE_AVLTREE
 CFLAGS += -DSET_USE_RBTREE
@@ -26,9 +30,52 @@
 	$(LIB)/rbtree.c \
 	$(LIB)/thread.c \
 	$(LIB)/vector.c \
+	$(LIB)/memory.c
 #
 OBJS := ${SRCS:.c=.o}
 
+RUNPARAMS := -a15 -i inputs/ttimeu1000000.2
+
+.PHONY:	run1 run2 run4 run6 run8 run12 run16 run32 run64 run128 run-16 run-32 run-64
+
+run1:
+	$(PROGRAM) $(RUNPARAMS) -t1
+
+run2:
+	$(PROGRAM) $(RUNPARAMS) -t2
+
+run4:
+	$(PROGRAM) $(RUNPARAMS) -t4
+
+run6:
+	$(PROGRAM) $(RUNPARAMS) -t6
+
+run8:
+	$(PROGRAM) $(RUNPARAMS) -t8
+
+run12:
+	$(PROGRAM) $(RUNPARAMS) -t12
+
+run16:
+	$(PROGRAM) $(RUNPARAMS) -t16
+
+run32:
+	$(PROGRAM) $(RUNPARAMS) -t32
+
+run64:
+	$(PROGRAM) $(RUNPARAMS) -t64
+
+run128:
+	$(PROGRAM) $(RUNPARAMS) -t128
+
+run-16:
+	$(PROGRAM) $(RUNPARAMS) -t-16
+
+run-32:
+	$(PROGRAM) $(RUNPARAMS) -t-32
+
+run-64:
+	$(PROGRAM) $(RUNPARAMS) -t-64
 
 # ==============================================================================
 #
diff -Naur -x .svn stamp-0.9.10/yada/Makefile.hle_intel stamp-0.9.10_Distribute/yada/Makefile.hle_intel
--- stamp-0.9.10/yada/Makefile.hle_intel	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/yada/Makefile.hle_intel	2014-12-18 12:40:31.223763542 +0900
@@ -0,0 +1,35 @@
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.hle_intel
+
+.PHONY: test_coordinate
+test_coordinate: CFLAGS += -DTEST_COORDINATE
+test_coordinate:
+	$(CC) $(CFLAGS) coordinate.c -lm -o $@
+
+.PHONY: test_element
+test_element: CFLAGS += -DTEST_ELEMENT
+test_element: LIB_SRCS := $(LIB)/{heap,list,pair,avltree}.c
+test_element:
+	$(CC) $(CFLAGS) element.c coordinate.c $(LIB_SRCS) -lm -o $@
+
+.PHONY: test_mesh
+test_mesh: CFLAGS += -DTEST_MESH
+test_mesh: LIB_SRCS := $(LIB)/{heap,list,pair,avltree,queue,rbtree,random,mt19937ar}.c
+test_mesh:
+	$(CC) $(CFLAGS) mesh.c element.c coordinate.c $(LIB_SRCS) -lm -o $@
+
+# ==============================================================================
+#
+# Makefile.hle_intel
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/yada/Makefile.htm_ibm stamp-0.9.10_Distribute/yada/Makefile.htm_ibm
--- stamp-0.9.10/yada/Makefile.htm_ibm	1970-01-01 09:00:00.000000000 +0900
+++ stamp-0.9.10_Distribute/yada/Makefile.htm_ibm	2014-12-18 12:40:41.052755383 +0900
@@ -0,0 +1,35 @@
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+# Copyright (c) IBM Corp. 2014, and others.
+
+
+include ../common/Defines.common.mk
+include ./Defines.common.mk
+include ../common/Makefile.htm_ibm
+
+.PHONY: test_coordinate
+test_coordinate: CFLAGS += -DTEST_COORDINATE
+test_coordinate:
+	$(CC) $(CFLAGS) coordinate.c -lm -o $@
+
+.PHONY: test_element
+test_element: CFLAGS += -DTEST_ELEMENT
+test_element: LIB_SRCS := $(LIB)/{heap,list,pair,avltree}.c
+test_element:
+	$(CC) $(CFLAGS) element.c coordinate.c $(LIB_SRCS) -lm -o $@
+
+.PHONY: test_mesh
+test_mesh: CFLAGS += -DTEST_MESH
+test_mesh: LIB_SRCS := $(LIB)/{heap,list,pair,avltree,queue,rbtree,random,mt19937ar}.c
+test_mesh:
+	$(CC) $(CFLAGS) mesh.c element.c coordinate.c $(LIB_SRCS) -lm -o $@
+
+# ==============================================================================
+#
+# Makefile.htm_ibm
+#
+# ==============================================================================
+
diff -Naur -x .svn stamp-0.9.10/yada/yada.c stamp-0.9.10_Distribute/yada/yada.c
--- stamp-0.9.10/yada/yada.c	2008-09-09 07:42:09.000000000 +0900
+++ stamp-0.9.10_Distribute/yada/yada.c	2014-12-18 12:25:15.449567379 +0900
@@ -67,10 +67,15 @@
  *
  * =============================================================================
  */
+/* Copyright (c) IBM Corp. 2014. */
 
 
 #include <assert.h>
+#if defined(__370__) || defined(_AIX)
+#include <unistd.h>  /* For getopt() */
+#else
 #include <getopt.h>
+#endif
 #include <stdio.h>
 #include <stdlib.h>
 #include "region.h"
@@ -80,6 +85,10 @@
 #include "thread.h"
 #include "timer.h"
 #include "tm.h"
+#if defined(__bgq__)
+#include <stdint.h>
+#include <spi/include/kernel/location.h>
+#endif
 
 
 #define PARAM_DEFAULT_INPUTPREFIX ("")
@@ -204,7 +213,7 @@
 
         element_t* elementPtr;
 
-        TM_BEGIN();
+        TM_BEGIN_ID(0);
         elementPtr = TMHEAP_REMOVE(workHeapPtr);
         TM_END();
         if (elementPtr == NULL) {
@@ -212,7 +221,7 @@
         }
 
         bool_t isGarbage;
-        TM_BEGIN();
+        TM_BEGIN_ID(1);
         isGarbage = TMELEMENT_ISGARBAGE(elementPtr);
         TM_END();
         if (isGarbage) {
@@ -225,12 +234,12 @@
 
         long numAdded;
 
-        TM_BEGIN();
+        TM_BEGIN_ID(2);
         PREGION_CLEARBAD(regionPtr);
         numAdded = TMREGION_REFINE(regionPtr, elementPtr, meshPtr);
         TM_END();
 
-        TM_BEGIN();
+        TM_BEGIN_ID(3);
         TMELEMENT_SETISREFERENCED(elementPtr, FALSE);
         isGarbage = TMELEMENT_ISGARBAGE(elementPtr);
         TM_END();
@@ -243,7 +252,7 @@
 
         totalNumAdded += numAdded;
 
-        TM_BEGIN();
+        TM_BEGIN_ID(4);
         TMREGION_TRANSFERBAD(regionPtr, workHeapPtr);
         TM_END();
 
@@ -251,7 +260,7 @@
 
     }
 
-    TM_BEGIN();
+    TM_BEGIN_ID(5);
     TM_SHARED_WRITE(global_totalNumAdded,
                     TM_SHARED_READ(global_totalNumAdded) + totalNumAdded);
     TM_SHARED_WRITE(global_numProcess,
@@ -277,6 +286,46 @@
      */
 
     parseArgs(argc, (char** const)argv);
+#if defined(__bgq__)
+    if (global_numThread < 0) {
+	uint32_t rank;
+	long maxThreads;
+
+	maxThreads = -global_numThread;
+	rank = Kernel_GetRank();
+	switch (rank) {
+	case 0:
+	    global_numThread = 1;
+	    break;
+#if defined(GLOBAL_LOCK) || defined(HTM_IBM)
+	case 1:
+	    global_numThread = 2;
+	    break;
+	case 2:
+	    global_numThread = 4;
+	    break;
+	case 3:
+	    global_numThread = 8;
+	    break;
+	case 4:
+	    global_numThread = 16;
+	    break;
+	case 5:
+	    global_numThread = 32;
+	    break;
+	case 6:
+	    global_numThread = 64;
+	    break;
+#endif
+	default:
+	    exit(0);
+	    break;
+	}
+	if (maxThreads < global_numThread) {
+	    exit(0);
+	}
+    }
+#endif
     SIM_GET_NUM_CPU(global_numThread);
     TM_STARTUP(global_numThread);
     P_MEMORY_STARTUP(global_numThread);
